%if 0%{?fedora} || 0%{?rhel} == 6
%global with_devel 1
%global with_bundled 0
%global with_debug 1
# most likely need to set etcd key with flannel configuration
%global with_check 0
%global with_unit_test 1
%else
%global with_devel 0
%global with_bundled 1
%global with_debug 0
%global with_check 0
%global with_unit_test 0
%endif

%if 0%{?with_debug}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

%if ! 0%{?gobuild:1}
%define gobuild(o:) go build -ldflags "${LDFLAGS:-} -B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \\n')" -a -v -x %{?**};
%endif

%global provider	github
%global provider_tld	com
%global project		coreos
%global repo		fleet
# https://github.com/coreos/fleet
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global import_path     %{provider_prefix}
%global commit		2d5c6bb0751ad3a50c0a219158439071a59e549f
%global shortcommit	%(c=%{commit}; echo ${c:0:7})

Name:		fleet
Version:	0.9.0
Release:	12%{?dist}
Summary:	A distributed init system

License:	ASL 2.0
URL:            https://%{provider_prefix}
Source0:	https://%{provider_prefix}/archive/v%{version}/%{name}-%{version}.tar.gz
Source1:	%{name}.service
Source2:	%{name}.tmpfiles.conf
Source3:	%{name}.polkit.rules
Patch1:		%{name}-0001-Don-t-use-Godeps.patch
Patch3:		%{name}-0003-Adapt-to-a-new-import-path.patch

# e.g. el6 has ppc64 arch without gcc-go, so EA tag is required
ExclusiveArch:  %{?go_arches:%{go_arches}}%{!?go_arches:%{ix86} x86_64 %{arm}}
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires:  %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}

%if ! 0%{?with_bundled}
# fleetd/fleet.go
BuildRequires: golang(github.com/rakyll/globalconf)
%endif

BuildRequires:	systemd

Requires(pre):	shadow-utils
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

%description
%{summary}.

%if 0%{?with_devel} || ! 0%{?with_bundled}
%package devel
Summary:       %{summary}
BuildArch:     noarch

%if 0%{?with_check} || ! 0%{?with_bundled}
BuildRequires: golang(google.golang.org/api/googleapi)
BuildRequires: golang(github.com/coreos/go-semver/semver)
BuildRequires: golang(github.com/coreos/go-systemd/activation)
BuildRequires: golang(github.com/coreos/go-systemd/dbus)
BuildRequires: golang(github.com/coreos/go-systemd/unit)
BuildRequires: golang(github.com/docker/libcontainer/netlink)
BuildRequires: golang(github.com/jonboulle/clockwork)
BuildRequires: golang(golang.org/x/crypto/ssh)
BuildRequires: golang(golang.org/x/crypto/ssh/agent)
BuildRequires: golang(golang.org/x/crypto/ssh/terminal)
%endif

Requires:      golang(google.golang.org/api/googleapi)
Requires:      golang(github.com/coreos/go-semver/semver)
Requires:      golang(github.com/coreos/go-systemd/activation)
Requires:      golang(github.com/coreos/go-systemd/dbus)
Requires:      golang(github.com/coreos/go-systemd/unit)
Requires:      golang(github.com/docker/libcontainer/netlink)
Requires:      golang(github.com/jonboulle/clockwork)
Requires:      golang(golang.org/x/crypto/ssh)
Requires:      golang(golang.org/x/crypto/ssh/agent)
Requires:      golang(golang.org/x/crypto/ssh/terminal)

Provides:      golang(%{import_path}/agent) = %{version}-%{release}
Provides:      golang(%{import_path}/api) = %{version}-%{release}
Provides:      golang(%{import_path}/client) = %{version}-%{release}
Provides:      golang(%{import_path}/config) = %{version}-%{release}
Provides:      golang(%{import_path}/engine) = %{version}-%{release}
Provides:      golang(%{import_path}/etcd) = %{version}-%{release}
Provides:      golang(%{import_path}/functional/platform) = %{version}-%{release}
Provides:      golang(%{import_path}/functional/util) = %{version}-%{release}
Provides:      golang(%{import_path}/heart) = %{version}-%{release}
Provides:      golang(%{import_path}/job) = %{version}-%{release}
Provides:      golang(%{import_path}/log) = %{version}-%{release}
Provides:      golang(%{import_path}/machine) = %{version}-%{release}
Provides:      golang(%{import_path}/pkg) = %{version}-%{release}
Provides:      golang(%{import_path}/registry) = %{version}-%{release}
Provides:      golang(%{import_path}/resource) = %{version}-%{release}
Provides:      golang(%{import_path}/schema) = %{version}-%{release}
Provides:      golang(%{import_path}/scripts) = %{version}-%{release}
Provides:      golang(%{import_path}/server) = %{version}-%{release}
Provides:      golang(%{import_path}/ssh) = %{version}-%{release}
Provides:      golang(%{import_path}/systemd) = %{version}-%{release}
Provides:      golang(%{import_path}/unit) = %{version}-%{release}
Provides:      golang(%{import_path}/version) = %{version}-%{release}

%description devel
%{summary}

This package contains library source intended for
building other packages which use import path with
%{import_path} prefix.
%endif

%if 0%{?with_unit_test} && 0%{?with_devel}
%package unit-test-devel
Summary:         Unit tests for %{name} package
%if 0%{?with_check}
#Here comes all BuildRequires: PACKAGE the unit tests
#in %%check section need for running
%endif

# test subpackage tests code from devel subpackage
Requires:        %{name}-devel = %{version}-%{release}

%if 0%{?with_check} && ! 0%{?with_bundled}
%endif

%description unit-test-devel
%{summary}

This package contains unit tests for project
providing packages with %{import_path} prefix.
%endif

%prep
%setup -q -n %{repo}-%{version}
%patch1 -p1 -b .nogodeps
%patch3 -p1 -b .new_api_path

%build
mkdir -p src/github.com/coreos
ln -s ../../../ src/github.com/coreos/fleet

%if ! 0%{?with_bundled}
export GOPATH=$(pwd):%{gopath}
%else
export GOPATH=$(pwd):$(pwd)/Godeps/_workspace:%{gopath}
%endif

%gobuild -o bin/fleetd   %{import_path}/fleetd
%gobuild -o bin/fleetctl %{import_path}/fleetctl

%install
install -D -p -m 0755 bin/%{name}ctl %{buildroot}%{_bindir}/%{name}ctl
install -D -p -m 0755 bin/%{name}d %{buildroot}%{_bindir}/%{name}d
install -D -p -m 0644 %{SOURCE1} %{buildroot}%{_unitdir}/%{name}.service

# Create home directory
install -d -m 0755 %{buildroot}/run/%{name}

# Create directory for config
install -D -p -m 0644 %{name}.conf.sample %{buildroot}%{_sysconfdir}/%{name}/%{name}.conf

install -D -p -m 0644 %{SOURCE2} %{buildroot}%{_tmpfilesdir}/%{name}.conf

install -D -p -m 0644 %{SOURCE3} %{buildroot}%{_datadir}/polkit-1/rules.d/%{name}.rules

# source codes for building projects
%if 0%{?with_devel} || ! 0%{?with_bundled}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
echo "%%dir %%{gopath}/src/%%{import_path}/." >> devel.file-list
# find all *.go but no *_test.go files and generate devel.file-list
for file in $(find . -iname "*.go" \! -iname "*_test.go" | egrep -v "./Godeps/_workspace/src") ; do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> devel.file-list
done
%endif

# testing files for this project
%if 0%{?with_unit_test} && 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
# find all *_test.go files and generate unit-test-devel.file-list
for file in $(find . -iname "*_test.go" | egrep -v "./Godeps/_workspace/src") ; do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> unit-test-devel.file-list
done
%endif

%if 0%{?with_devel}
sort -u -o devel.file-list devel.file-list
%endif

%check
%if 0%{?with_check} && 0%{?with_unit_test} && 0%{?with_devel}
%if ! 0%{?with_bundled}
export GOPATH=%{buildroot}/%{gopath}:%{gopath}
%else
export GOPATH=%{buildroot}/%{gopath}:$(pwd)/Godeps/_workspace:%{gopath}
%endif

%if ! 0%{?gotest:1}
%global gotest go test
%endif

%gotest %{import_path}/agent
%gotest %{import_path}/api
%gotest %{import_path}/config
%gotest %{import_path}/engine
%gotest %{import_path}/etcd
%gotest %{import_path}/fleetctl
%gotest %{import_path}/functional
%gotest %{import_path}/job
%gotest %{import_path}/machine
%gotest %{import_path}/pkg
%gotest %{import_path}/registry
%gotest %{import_path}/resource
%gotest %{import_path}/ssh
%gotest %{import_path}/systemd
%gotest %{import_path}/unit
%endif

%pre
getent group %{name} >/dev/null || groupadd -r %{name}
getent passwd %{name} >/dev/null || useradd -r -g %{name} -d /run/%{name} \
	-s /sbin/nologin -c "%{name} user" %{name}

%post
%systemd_post %{name}.service

%preun
%systemd_preun %{name}.service

%postun
%systemd_postun %{name}.service

#define license tag if not already defined
%{!?_licensedir:%global license %doc}

%files
%license LICENSE
%doc CONTRIBUTING.md README.md Documentation/ examples/ DCO MAINTAINERS NOTICE
%dir %attr(750,%{name},%{name}) %{_sysconfdir}/%{name}
%attr(750,%{name},%{name}) %{_sysconfdir}/%{name}/%{name}.conf
%{_bindir}/%{name}ctl
%{_bindir}/%{name}d
%dir %attr(750,%{name},%{name}) /run/%{name}
%{_unitdir}/%{name}.service
%{_tmpfilesdir}/%{name}.conf
%{_datadir}/polkit-1/rules.d/%{name}.rules

%if 0%{?with_devel} || ! 0%{?with_bundled}
%files devel -f devel.file-list
%license LICENSE
%doc CONTRIBUTING.md README.md Documentation/ examples/ DCO MAINTAINERS NOTICE
%dir %{gopath}/src/%{provider}.%{provider_tld}/%{project}
%endif

%if 0%{?with_unit_test} && 0%{?with_devel}
%files unit-test-devel -f unit-test-devel.file-list
%license LICENSE
%doc CONTRIBUTING.md README.md Documentation/ examples/ DCO MAINTAINERS NOTICE
%endif

%changelog
* Thu Jul 21 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.9.0-12
- https://fedoraproject.org/wiki/Changes/golang1.7

* Sat Apr  9 2016 Peter Robinson <pbrobinson@fedoraproject.org> 0.9.0-11
- Rebuild (aarch64)

* Thu Mar 17 2016 jchaloup <jchaloup@redhat.com> - 0.9.0-10
- Polish the spec file
  resolves: #1318576

* Thu Mar  3 2016 Peter Lemenkov <lemenkov@gmail.com> - 0.9.0-9
- Remove no longer required patch (we've got a very recent go-systemd library now)

* Mon Feb 22 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.9.0-8
- https://fedoraproject.org/wiki/Changes/golang1.6

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.0-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.9.0-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Mon Mar 30 2015 jchaloup <jchaloup@redhat.com> - 0.9.0-5
- Add debug info
  related: #1175471

* Wed Jan 21 2015 jchaloup <jchaloup@redhat.com> - 0.9.0-4
- Add devel subpackage, add some global variables

* Thu Dec 18 2014 Peter Lemenkov <lemenkov@gmail.com> - 0.9.0-3
- More transparent and verbose build process

* Tue Dec  9 2014 Peter Lemenkov <lemenkov@gmail.com> - 0.9.0-2
- Properly run as user

* Sun Dec 07 2014 Peter Lemenkov <lemenkov@gmail.com> - 0.9.0-1
- Initial creation
